/*
   Subscribe Tech Vegan - For Electronics, Electrical, Computer Science Projects Contact +91-9890345539
   Get Projects in Affordable Prices
   Special Discount on IoT Projects (Internet of Things)
   WhatsApp +919890345539
*/
#include "U8glib.h"
#include <SPI.h>
#include <Pixy2.h>
#include <Wire.h>              //Include the Wire Library
#include <HTInfraredSeeker.h>  //Include the IR Seeker Library
#include <EEPROM.h>
#include <Wire.h>
#include <Adafruit_Sensor.h>
#include <Adafruit_BNO055.h>
#include <utility/imumaths.h>

//------------------------EEPROM-------------------------
#define numberSensors 8
#define numberTests 10
#define increaseFactor 2
#define increaseNumber 150
int ciaraInput[numberSensors] = { 0, 0, 0, 0, 0, 0, 0, 0 };
int zostavaTestov = numberTests;
int compassStep = 0;
int compassSetVal[4];
int motorSpeedSet[4];

int dirs[6];
int speedPins[6];
int dirPins[6];
int ciaraPins[8];
int ciaraVal[8];
int compassVal[4];
int oponentsGoal = 0;
int motorSpeed[4];
int strategy = 0;
int misugeVal = 0;
int shootingDistance = 0;


int adressDirs = 0;
int adressSpeedPins = 0;
int adressDirPins = 0;
int adressCiaraPins = 0;
int adressCiara = 0;
int adressCompass = 0;
int adressGoal = 0;
int adressMotorSpeed = 0;
int adressStrategy = 0;
int adressMisugeVal = 0;
int adressShootingDistance = 0;
int adress = 0;

//--------------------MISUGE--------------------
//ako dlho ide dopredu
#define misugeForward 80
#define misugeReset 60
uint16_t misuge = 0;
uint16_t mamLoptu = 0;
//#define misugeVal 100
int jedenKrat = 0;
int mamLoptuCas = 0;

//---------------------GOMBIKY------------------
#define EXIT_BUTTON 24
#define UP_BUTTON 25
#define OK_BUTTON 26
#define DOWN_BUTTON 27
#define BACK_BUTTON 28
#define runPin 26
#define driblerPin A14
#define ledBrana A14
#define hodnotaLedBrany 250

//----------------------KAMERA------------------
#define lopta 1
#define branaZlta 3
#define branaModra 2
//#define shootingDistance 26
#define leftPerimeter 130
#define rightPerimeter 190
//105,212
#define leftPerimeterGoal 120
#define rightPerimeterGoal 200
#define ballSideY 100
#define ballSideY_forward 125
uint16_t blocks;
int xBrana = 0;
int yBrana = 0;
int xLopta = 0;
int yLopta = 0;
double GyroAngle = 0;

//------------------COMPASS----------------------
#define compassValues 4
int compassInput[compassValues] = { 0, 0, 0, 0 };
int GyrL = 0;
int GyrR = 0;
int SupportL = 0;
int SupportR = 0;
Adafruit_BNO055 bno = Adafruit_BNO055(55, 0x28);

//-------------------CIARA-----------------------
#define biela1 680
#define biela2 450
#define biela3 570
#define mainDelay 150
#define ciaraLoop 40

//-------------------MOTORY-----------------------
#define KICKER 6
#define DRIBBLER 5

int fullSpeed = 0;
int mainSpeed = 0;
int driblerSpeed = 100;
int turnSpeed = 0;
int turnSpeedDotacanie = 0;
int defendSpeed = 0;
int arrowSpeed = 0;
int adjustSpeed = 8;

#define driblerPin A14
#define ledBrana A14
#define hodnotaLedBrany 200

Pixy2 pixy;
InfraredResult InfraredBall;

//----------------------DISPLAY-------------------
#define MAIN_PAGE 0
#define RUN_PROGRAM 0
#define SETUP_PAGE 1
#define STRATEGY_PAGE 2
#define VIEW_PAGE 3
#define BRANA_PAGE 4
#define CIARA_PAGE 5
#define COMPASS_PAGE 6
#define RYCHLOST_MOTOROV_PAGE 7
#define MAIN_SPEED_PAGE 8
#define FULL_SPEED_PAGE 9
#define TURN_SPEED_PAGE 10
#define DEFEND_SPEED_PAGE 11
#define SENSORS_PAGE 12
#define PLAYSTYLE_PAGE 13
#define MISUGE_PAGE 14
#define SHOOTING_DISTANCE_PAGE 15

#define LINE_HEIGHT 15
#define sensorPages 6
int viewMode = 0;
int misugeValSet = 0;
int shootingDistanceSet = 0;

U8GLIB_SH1106_128X64 oled(U8G_I2C_OPT_NONE);

const int pageCount = 16;
int menuPos[pageCount] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int maxMenuPos[pageCount] = { 3, 3, 3, 3, 1, 0, 4, 3, 0, 0, 0, 0, 0, 0, 0, 0 };
int currentPage = 0;

int setupRun = 1;


void pageMain(void);
void pageSetup(void);
void pageStrategy(void);
void pageView(void);
void pageBrana(void);
void pageCiara(void);
void pageCompass(void);
void pageRychlostMotorov(void);
void pageMainSpeed(void);
void pageFullSpeed(void);
void pageTurnSpeed(void);
void pageDefendSpeed(void);
void pageSensors(void);
void pagePlaystyle(void);
void pageMisuge(void);
void pageShootingDistance(void);

void (*pages[pageCount])() = { pageMain, pageSetup, pageStrategy, pageView, pageBrana, pageCiara, pageCompass, pageRychlostMotorov, pageMainSpeed, pageFullSpeed, pageTurnSpeed, pageDefendSpeed, pageSensors,
                               pagePlaystyle, pageMisuge, pageShootingDistance };

void page1(void);

void setupPart(void);

void clearOLED() {
  oled.firstPage();
  do {
  } while (oled.nextPage());
}


//------------------------------------SET UP------------------------------------
void setup(void) {
  pixy.init();
  Serial.begin(9600);
  oled.setFont(u8g_font_profont11);
  if (!bno.begin()) {
    /* There was a problem detecting the BNO055 ... check your connections */
    Serial.print("Ooops, no BNO055 detected ... Check your wiring or I2C ADDR!");
    //while (1) ;
  }

  uint8_t system, gyro, accel, mag = 0;
  do {
    bno.getCalibration(&system, &gyro, &accel, &mag);
    Serial.print("CALIBRATION   ");
    Serial.println(mag);
    oled.firstPage();
    do {

      oled.setPrintPos(0, 10);
      oled.print("CALIBRATION   ");
      oled.setPrintPos(0, 25);
      oled.print(mag);
    } while (oled.nextPage());

  } while (mag < 3);



  Serial.print("MOTORS: ");
  EEPROM.get(adress, dirs);
  for (int i = 0; i < 6; i++) {
    Serial.print(dirs[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  adress += sizeof(dirs);
  adressSpeedPins = adress;
  EEPROM.get(adress, speedPins);
  for (int i = 0; i < 6; i++) {
    Serial.print(speedPins[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  adress += sizeof(speedPins);
  adressDirPins = adress;
  EEPROM.get(adress, dirPins);
  for (int i = 0; i < 6; i++) {
    Serial.print(dirPins[i]);
    Serial.print(" ");
  }
  Serial.print("\n");

  Serial.print("CIARA: ");
  adress += sizeof(dirPins);
  adressCiaraPins = adress;
  EEPROM.get(adress, ciaraPins);
  for (int i = 0; i < 8; i++) {
    Serial.print(ciaraPins[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  adress += sizeof(ciaraPins);
  adressCiara = adress;
  EEPROM.get(adress, ciaraVal);
  for (int i = 0; i < 8; i++) {
    Serial.print(ciaraVal[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  Serial.print("COMPASS: ");
  adress += sizeof(ciaraVal);
  adressCompass = adress;
  EEPROM.get(adress, compassVal);
  for (int i = 0; i < 4; i++) {
    Serial.print(compassVal[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  adress += sizeof(compassVal);
  adressGoal = adress;
  EEPROM.get(adress, oponentsGoal);
  Serial.print("UTOCIM NA: ");
  Serial.println(oponentsGoal);

  adress += sizeof(oponentsGoal);
  adressMotorSpeed = adress;
  EEPROM.get(adressMotorSpeed, motorSpeed);
  for (int i = 0; i < 4; i++) {
    Serial.print(motorSpeed[i]);
    Serial.print(" ");
  }
  Serial.print("\n");
  adress += sizeof(motorSpeed);
  adressStrategy = adress;
  EEPROM.get(adressStrategy, strategy);
  Serial.print("Strategia: ");
  Serial.println(strategy);

  adress += sizeof(strategy);
  adressMisugeVal = adress;
  EEPROM.get(adressMisugeVal, misugeVal);
  Serial.print("Hodnota Misuge: ");
  Serial.println(misugeVal);

  adress += sizeof(misugeVal);
  adressShootingDistance = adress;
  EEPROM.get(adressShootingDistance, shootingDistance);
  Serial.print("Hodnota Shootinng Distance: ");
  Serial.println(shootingDistance);

  while (setupRun) { setupPart(); }
  mainSpeed = motorSpeed[0];
  fullSpeed = motorSpeed[1];
  arrowSpeed = motorSpeed[1];
  driblerSpeed = 100;
  turnSpeed = motorSpeed[2];
  turnSpeedDotacanie = motorSpeed[2] - 5;
  defendSpeed = motorSpeed[3];

  SupportL = compassVal[0];
  GyrL = compassVal[1];
  GyrR = compassVal[2];
  SupportR = compassVal[3];

  /*ciaraVal[0] = biela1;
  ciaraVal[1] = biela3;
  ciaraVal[2] = biela1;
  ciaraVal[3] = biela1;
  ciaraVal[4] = biela1;
  ciaraVal[5] = biela1;
  ciaraVal[6] = biela1;
  ciaraVal[7] = biela1;*/
}
//---------------------------SET UP--------------------------------------


double getRotation() {
  sensors_event_t orientationData;  // , angVelocityData , linearAccelData;
  bno.getEvent(&orientationData, Adafruit_BNO055::VECTOR_EULER);
  return (orientationData.orientation.x - 0);
}

int findXBySignature(int signID) {

  int i;

  if (blocks) {
    for (i = 0; i < blocks; i = i + 1) {

      if (pixy.ccc.blocks[i].m_signature == signID) {
        return pixy.ccc.blocks[i].m_x + 1;
      }
    }
  } else {
    return 0;
  }
  return 0;
}


int findYBySignature(int signID) {

  int i;

  if (blocks) {
    for (i = 0; i < blocks; i = i + 1) {

      if (pixy.ccc.blocks[i].m_signature == signID) {
        return pixy.ccc.blocks[i].m_y + 1;
      }
    }
  } else {
    return 0;
  }
  return 0;
}


void motor_control(int cislo_motoru, int rychlost) {
  //cislo motoru 1-4 smer dorpedu/dozadu rychlost 0-100
  int rychlostMapped;
  int dir;


  //Serial.println(rychlost);

  if (rychlost == 0) {
    digitalWrite(speedPins[cislo_motoru - 1], LOW);
    digitalWrite(dirPins[cislo_motoru - 1], LOW);

  } else if (rychlost < 0) {
    rychlostMapped = map(rychlost * -1, 0, 100, 0, 255);
    //Serial.println(rychlostMapped);
    analogWrite(speedPins[cislo_motoru - 1], rychlostMapped);
    if (dirs[cislo_motoru - 1] == 1) {
      digitalWrite(dirPins[cislo_motoru - 1], LOW);
    } else {
      digitalWrite(dirPins[cislo_motoru - 1], HIGH);
    }


    //int rychlostMapped = map(rychlost,dirs[cislo_motoru-1] * -100,dirs[cislo_motoru-1] *100,0,255);
  } else if (rychlost > 0) {
    rychlostMapped = map(rychlost, 0, 100, 0, 255);
    analogWrite(speedPins[cislo_motoru - 1], rychlostMapped);
    //Serial.println(rychlostMapped);
    if (dirs[cislo_motoru - 1] == -1) {
      digitalWrite(dirPins[cislo_motoru - 1], LOW);
      //Serial.println("LOW");
    } else {
      digitalWrite(dirPins[cislo_motoru - 1], HIGH);
      //Serial.println("HIGH");
    }


    //int rychlostMapped = map(rychlost,dirs[cislo_motoru-1] * -100,dirs[cislo_motoru-1] *100,0,255);
  }
}

void kick() {
  motors(100, 100, 100, 100);
  motor_control(5, driblerSpeed);
  //delay(30);
  motor_control(6, 100);
  move_backward();
  delay(50);
  motor_control(6, 0);
  delay(50);
  //delay(100);
}
void kick2() {
  motors(100, 100, 100, 100);
  motor_control(5, driblerSpeed);
  //delay(30);
  motor_control(6, 100);
  move_backward();
  delay(50);
  motor_control(6, 0);
  delay(50);
  //delay(100);
}

void kickCiara() {
  motor_control(5, driblerSpeed);
  motors(-mainSpeed, -mainSpeed, -mainSpeed, -mainSpeed);
  motor_control(6, 100);
  move_backward();
  delay(50);
  motor_control(6, 0);
  delay(50);
  //delay(100);
}

void motors(int speed1, int speed2, int speed3, int speed4) {
  motor_control(1, speed1);
  motor_control(2, speed2);
  motor_control(3, speed3);
  motor_control(4, speed4);
}

//Motor Directions
void turn_left() {
  motors(-turnSpeed, -turnSpeed, turnSpeed, turnSpeed);
  motor_control(5, -driblerSpeed);
}
void turn_left_dotacanie() {
  motors(-turnSpeedDotacanie, -turnSpeedDotacanie, turnSpeedDotacanie, turnSpeedDotacanie);
  motor_control(5, -driblerSpeed);
}
void turn_left_defend() {
  motors(-defendSpeed, -defendSpeed, defendSpeed, defendSpeed);
  motor_control(5, -driblerSpeed);
}
void turn_right() {
  motors(turnSpeed, turnSpeed, -turnSpeed, -turnSpeed);
  motor_control(5, -driblerSpeed);
}
void turn_right_dotacanie() {
  motors(turnSpeedDotacanie, turnSpeedDotacanie, -turnSpeedDotacanie, -turnSpeedDotacanie);
  motor_control(5, -driblerSpeed);
}
void turn_right_defend() {
  motors(defendSpeed, defendSpeed, -defendSpeed, -defendSpeed);
  motor_control(5, -driblerSpeed);
}
void move_forward() {
  motors(mainSpeed, mainSpeed, mainSpeed, mainSpeed);
  motor_control(5, -driblerSpeed);
}
void move_forward_full() {
  motors(fullSpeed, fullSpeed, fullSpeed, fullSpeed);
  motor_control(5, -driblerSpeed);
}
void move_backward() {
  motors(-mainSpeed, -mainSpeed, -mainSpeed, -mainSpeed);
  motor_control(5, -driblerSpeed);
}
void move_backward_full() {
  motors(-fullSpeed, -fullSpeed, -fullSpeed, -fullSpeed);
  motor_control(5, -driblerSpeed);
}
void move_left() {
  motors(mainSpeed, -mainSpeed, mainSpeed, -mainSpeed);
  motor_control(5, -driblerSpeed);
}
void move_right() {
  motors(-mainSpeed, mainSpeed, -mainSpeed, mainSpeed);
  motor_control(5, -driblerSpeed);
}
void move_forward_right() {
  motors(0, arrowSpeed, 0, arrowSpeed);
  motor_control(5, -driblerSpeed);
}
void move_forward_right2() {
  motors(-adjustSpeed, arrowSpeed, adjustSpeed, arrowSpeed);
  motor_control(5, -driblerSpeed);
}
void move_forward_left() {
  motors(arrowSpeed, 0, arrowSpeed, 0);
  motor_control(5, -driblerSpeed);
}
void move_forward_left2() {
  motors(arrowSpeed, adjustSpeed, arrowSpeed, -adjustSpeed);
  motor_control(5, -driblerSpeed);
}
void move_backward_right() {
  motors(-arrowSpeed, 0, -arrowSpeed, 0);
  motor_control(5, -driblerSpeed);
}
void move_backward_left() {
  motors(0, -arrowSpeed, 0, -arrowSpeed);
  motor_control(5, -driblerSpeed);
}
void motors_stop() {
  motors(0, 0, 0, 0);
  motor_control(5, driblerSpeed * 0);
}

void kontrola() {
  int aVzadu1, aVpravo1, aVpredu1, aVlavo1, aVzadu2, aVpravo2, aVpredu2, aVlavo2;
  aVpredu1 = analogRead(ciaraPins[0]);
  aVpredu2 = analogRead(ciaraPins[1]);
  aVpravo1 = analogRead(ciaraPins[2]);
  aVpravo2 = analogRead(ciaraPins[3]);
  aVzadu1 = analogRead(ciaraPins[4]);
  aVzadu2 = analogRead(ciaraPins[5]);
  aVlavo1 = analogRead(ciaraPins[6]);
  aVlavo2 = analogRead(ciaraPins[7]);

  // Serial.println("Kontrola");
  Serial.print("aVpredu1   ");
  Serial.println(aVpredu1);
  Serial.print("aVpravo1   ");
  Serial.println(aVpravo1);
  Serial.print("aVzadu1   ");
  Serial.println(aVzadu1);
  Serial.print("aVlavo1   ");
  Serial.println(aVlavo1);
  Serial.println("");
  Serial.print("aVpredu2   ");
  Serial.println(aVpredu2);
  Serial.print("aVpravo2   ");
  Serial.println(aVpravo2);
  Serial.print("aVzadu2   ");
  Serial.println(aVzadu2);
  Serial.print("aVlavo2   ");
  Serial.println(aVlavo2);
  Serial.println("");
  Serial.println("");
}

void help() {
  int aVzadu1, aVpravo1, aVpredu1, aVlavo1, aVzadu2, aVpravo2, aVpredu2, aVlavo2;
  aVpredu1 = analogRead(ciaraPins[0]);
  aVpredu2 = analogRead(ciaraPins[1]);
  aVpravo1 = analogRead(ciaraPins[2]);
  aVpravo2 = analogRead(ciaraPins[3]);
  aVzadu1 = analogRead(ciaraPins[4]);
  aVzadu2 = analogRead(ciaraPins[5]);
  aVlavo1 = analogRead(ciaraPins[6]);
  aVlavo2 = analogRead(ciaraPins[7]);


  if (aVzadu1 > ciaraVal[4] || aVzadu2 > ciaraVal[5]) {
    move_forward();
    delay(50);

  } else if (aVlavo1 > ciaraVal[6] || aVlavo2 > ciaraVal[7]) {
    move_right();
    delay(50);
  } else if (aVpravo1 > ciaraVal[2] || aVpravo2 > ciaraVal[3]) {
    move_left();
    delay(50);
  } else if (aVpredu1 > ciaraVal[0] || aVpredu2 > ciaraVal[1]) {
    move_backward();
    delay(50);
  } else {
    delay(10);
  }
}




void ciara() {
  int aVzadu1, aVpravo1, aVpredu1, aVlavo1, aVzadu2, aVpravo2, aVpredu2, aVlavo2;
  aVpredu1 = analogRead(ciaraPins[0]);
  aVpredu2 = analogRead(ciaraPins[1]);
  aVpravo1 = analogRead(ciaraPins[2]);
  aVpravo2 = analogRead(ciaraPins[3]);
  aVzadu1 = analogRead(ciaraPins[4]);
  aVzadu2 = analogRead(ciaraPins[5]);
  aVlavo1 = analogRead(ciaraPins[6]);
  aVlavo2 = analogRead(ciaraPins[7]);

  blocks = pixy.ccc.getBlocks();
  xLopta = findXBySignature(lopta);
  if (xLopta > 0 || analogRead(driblerPin) < hodnotaLedBrany) {
    if (aVzadu1 > ciaraVal[4] || aVzadu2 > ciaraVal[5]) {
      move_forward();
      jedenKrat = 0;
      misuge += 10;
      delay(mainDelay + 50);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    } else if (aVpredu1 > ciaraVal[0] || aVpredu2 > ciaraVal[1]) {
      move_backward();
      jedenKrat = 0;
      delay(mainDelay);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    }

  } else {
    if (aVzadu1 > ciaraVal[4] || aVzadu2 > ciaraVal[5]) {
      move_forward();
      jedenKrat = 0;
      misuge += 10;
      delay(mainDelay + 50);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    } else if (aVlavo1 > ciaraVal[6] || aVlavo2 > ciaraVal[7]) {
      move_right();
      jedenKrat = 0;
      delay(mainDelay);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    } else if (aVpravo1 > ciaraVal[2] || aVpravo2 > ciaraVal[3]) {
      move_left();
      jedenKrat = 0;
      delay(mainDelay + 50);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    } else if (aVpredu1 > ciaraVal[0] || aVpredu2 > ciaraVal[1]) {
      move_backward();
      jedenKrat = 0;
      delay(mainDelay);
      for (int i = 0; i < ciaraLoop; i = i + 1) {
        help();
      }
    }
  }
}

void strategyPlay(int strategia) {
  switch (strategia) {
    case 1:
      if (analogRead(driblerPin) < hodnotaLedBrany) {
        if (xBrana > 0) {
          //Serial.print("Brana ");
          //Serial.print("\t");
          //Serial.print(xBrana);
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            move_forward_full();
            if (yBrana > shootingDistance) {
              kick2();
            } else {
              motor_control(5, -driblerSpeed);
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
          }

        } else {
          if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
            move_forward_full();
            kick2();
          } else if (GyroAngle < GyrL) {
            turn_right();
          } else {
            turn_left();
          }
        }

      } else {
        //-------------NEMAM_LOPTU--------------
        if (xBrana > 0) {
          //Serial.print("Brana ");
          //Serial.print("\t");
          //Serial.print(xBrana);
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            if (xLopta > 0) {
              if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
                if (yLopta > ballSideY_forward) {
                  move_forward();
                } else {
                  move_forward_full();
                }
              } else if (xLopta > rightPerimeter) {
                if (yLopta > ballSideY) {
                  move_right();
                } else {
                  move_forward_right();
                }
              } else if (xLopta < leftPerimeter) {
                if (yLopta > ballSideY) {
                  move_left();
                } else {
                  move_forward_left();
                }
              }
            } else {
              move_backward();
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
            mamLoptuCas = 0;
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
            mamLoptuCas = 0;
          }

        } else if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
          if (xLopta > 0) {
            if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
              if (yLopta > ballSideY_forward) {
                move_forward();
              } else {
                move_forward_full();
              }
            } else if (xLopta > rightPerimeter) {
              if (yLopta > ballSideY) {
                move_right();
              } else {
                move_forward_right();
              }
            } else if (xLopta < leftPerimeter) {
              if (yLopta > ballSideY) {
                move_left();
              } else {
                move_forward_left();
              }
            }
          } else {
            move_backward();
          }
        } else if (GyroAngle < GyrL) {
          turn_right();
        } else {
          turn_left();
        }
      }
      break;
    case 2:
      if (analogRead(driblerPin) < hodnotaLedBrany) {
        if (xBrana > 0) {
          //Serial.print("Brana ");
          //Serial.print("\t");
          //Serial.print(xBrana);
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            move_forward_full();
            if (yBrana > shootingDistance) {
              kick2();
            } else {
              motor_control(5, -driblerSpeed);
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
          }

        } else {
          if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
            move_forward_full();
            kick2();
          } else if (GyroAngle < GyrL) {
            turn_right();
          } else {
            turn_left();
          }
        }

      } else {
        //-------------NEMAM_LOPTU--------------
        if (xBrana > 0) {
          //Serial.print("Brana ");
          //Serial.print("\t");
          //Serial.print(xBrana);
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            if (xLopta > 0) {
              if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
                if (yLopta > ballSideY_forward) {
                  move_forward();
                } else {
                  move_forward_full();
                }
              } else if (xLopta > rightPerimeter) {
                if (yLopta > ballSideY) {
                  move_right();
                } else {
                  move_forward_right2();
                }
              } else if (xLopta < leftPerimeter) {
                if (yLopta > ballSideY) {
                  move_left();
                } else {
                  move_forward_left2();
                }
              }
            } else {
              move_backward();
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
            mamLoptuCas = 0;
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
            mamLoptuCas = 0;
          }

        } else if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
          if (xLopta > 0) {
            if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
              if (yLopta > ballSideY_forward) {
                move_forward();
              } else {
                move_forward_full();
              }
            } else if (xLopta > rightPerimeter) {
              if (yLopta > ballSideY) {
                move_right();
              } else {
                move_forward_right();
              }
            } else if (xLopta < leftPerimeter) {
              if (yLopta > ballSideY) {
                move_left();
              } else {
                move_forward_left();
              }
            }
          } else {
            move_backward();
          }
        } else if (GyroAngle < GyrL) {
          turn_right();
        } else {
          turn_left();
        }
      }

      break;
    case 3:
      if (analogRead(driblerPin) < hodnotaLedBrany) {
        if (xBrana > 0) {
          /*Serial.print("Brana ");
            Serial.print("\t");
            Serial.print(xBrana);*/
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            move_forward_full();
            if (yBrana > shootingDistance) {
              kick();
            } else {
              motor_control(5, -driblerSpeed);
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
          }

        } else {
          if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
            move_forward_full();
            kick2();
          } else if (GyroAngle < GyrL) {
            turn_right();
          } else {
            turn_left();
          }
        }

      } else {
        //-------------NEMAM_LOPTU--------------
        if (xBrana > 0) {
          if (yBrana > shootingDistance) {
            /*Serial.print("Brana ");
              Serial.print("\t");
              Serial.print(xBrana);*/
            if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
              if (xLopta > 0) {
                if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
                  move_forward_full();
                } else if (xLopta > rightPerimeter) {
                  if (yLopta > ballSideY) {
                    move_right();
                  } else {
                    move_forward_right();
                  }
                } else if (xLopta < leftPerimeter) {
                  if (yLopta > ballSideY) {
                    move_left();
                  } else {
                    move_forward_left();
                  }
                }
              } else {
                move_backward();
              }
            } else if (xBrana > rightPerimeterGoal) {
              turn_right();
              mamLoptuCas = 0;
            } else if (xBrana < leftPerimeterGoal) {
              turn_left();
              mamLoptuCas = 0;
            }
          } else if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
            if (xLopta > 0) {
              if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
                if (yLopta > ballSideY_forward) {
                  move_forward();
                } else {
                  move_forward_full();
                }
              } else if (xLopta > rightPerimeter) {
                if (yLopta > ballSideY) {
                  move_right();
                } else {
                  move_forward_right();
                }
              } else if (xLopta < leftPerimeter) {
                if (yLopta > ballSideY) {
                  move_left();
                } else {
                  move_forward_left();
                }
              }
            } else {
              move_backward();
            }
          } else if (GyroAngle < GyrL) {
            turn_right();
          } else {
            turn_left();
          }

        } else if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
          if (xLopta > 0) {
            if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
              if (yLopta > ballSideY_forward) {
                move_forward();
              } else {
                move_forward_full();
              }
            } else if (xLopta > rightPerimeter) {
              if (yLopta > ballSideY) {
                move_right();
              } else {
                move_forward_right();
              }
            } else if (xLopta < leftPerimeter) {
              if (yLopta > ballSideY) {
                move_left();
              } else {
                move_forward_left();
              }
            }
          } else {
            move_backward();
          }
        } else if (GyroAngle < GyrL) {
          turn_right();
        } else {
          turn_left();
        }
      }
      break;
    case 4:
      if (analogRead(driblerPin) < hodnotaLedBrany) {
        if (xBrana > 0) {
          //Serial.print("Brana ");
          //Serial.print("\t");
          //Serial.print(xBrana);
          if (xBrana >= leftPerimeterGoal && xBrana <= rightPerimeterGoal) {
            move_forward_full();
            if (yBrana > shootingDistance) {
              kick2();
            } else {
              motor_control(5, -driblerSpeed);
            }
          } else if (xBrana > rightPerimeterGoal) {
            turn_right_dotacanie();
          } else if (xBrana < leftPerimeterGoal) {
            turn_left_dotacanie();
          }

        } else {
          if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
            move_forward_full();
            kick2();
          } else if (GyroAngle < GyrL) {
            turn_right();
          } else {
            turn_left();
          }
        }

      } else {
        //-------------NEMAM_LOPTU--------------
        mamLoptuCas = 0;
        if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
          if (xLopta > 0) {
            if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
              if (yLopta > ballSideY_forward) {
                move_forward();
              } else {
                move_forward_full();
              }
            } else if (xLopta > rightPerimeter) {
              if (yLopta > ballSideY) {
                move_right();
              } else {
                move_forward_right();
              }
            } else if (xLopta < leftPerimeter) {
              if (yLopta > ballSideY) {
                move_left();
              } else {
                move_forward_left();
              }
            }
          } else {
            move_backward();
          }
        } else if (GyroAngle < GyrL) {
          turn_right();
        } else if (GyroAngle > GyrR) {
          turn_left();
        }
      }
      break;
  }
  /*Serial.print("\t");               
    Serial.print("Lopta ");
    Serial.print("\t");
    Serial.println(xLopta);
    Serial.print("\t");               
    Serial.print("GyroAngle ");
    Serial.print("\t");
    Serial.println(GyroAngle);*/
}

void setupPart(void) {
  //oled.setRot180();
  if (currentPage == CIARA_PAGE) {
    if (digitalRead(OK_BUTTON)) {
      if (zostavaTestov > 0) {
        for (int i = 0; i < numberSensors; i++) {
          ciaraInput[i] += analogRead(ciaraPins[i]);
        }


        zostavaTestov -= 1;
        //Serial.print("Zostava testov ciara: ");
        //Serial.println(zostavaTestov);
        delay(500);
      }
    }
  };

  if (currentPage == CIARA_PAGE && zostavaTestov == 0) {

    for (int i = 0; i < numberSensors; i++) {
      ciaraInput[i] = ciaraInput[i] / numberTests * increaseFactor + increaseNumber;
      ciaraVal[i] = ciaraInput[i];
      //Serial.println(ciaraInput[i]);
    }
    EEPROM.put(adressCiara, ciaraInput);
    for (int i = 0; i < numberSensors; i++) {
      ciaraInput[i] = 0;
    }
    zostavaTestov = numberTests;
    currentPage = SETUP_PAGE;
  }

  if (digitalRead(OK_BUTTON)) {
    if (currentPage == MAIN_PAGE) {
      if (menuPos[MAIN_PAGE] == 0) {

        setupRun = 0;
        delay(20);
        ///// run / ostry program
      } else if (menuPos[MAIN_PAGE] == 1) {
        currentPage = SETUP_PAGE;
      } else if (menuPos[MAIN_PAGE] == 2) {
        currentPage = STRATEGY_PAGE;
      } else if (menuPos[MAIN_PAGE] == 3) {
        currentPage = VIEW_PAGE;
      }
    } else if (currentPage == SETUP_PAGE) {
      if (menuPos[SETUP_PAGE] == 0) {
        currentPage = BRANA_PAGE;

      } else if (menuPos[SETUP_PAGE] == 1) {
        currentPage = CIARA_PAGE;

      } else if (menuPos[SETUP_PAGE] == 2) {
        currentPage = COMPASS_PAGE;
      } else if (menuPos[SETUP_PAGE] == 3) {
        currentPage = RYCHLOST_MOTOROV_PAGE;
      }
    } else if (currentPage == VIEW_PAGE) {
      if (menuPos[VIEW_PAGE] == 0) {
        currentPage = SENSORS_PAGE;

      } else if (menuPos[VIEW_PAGE] == 1) {
        currentPage = PLAYSTYLE_PAGE;

      } else if (menuPos[VIEW_PAGE] == 2) {
        currentPage = MISUGE_PAGE;
        misugeValSet = misugeVal;
      } else if (menuPos[VIEW_PAGE] == 3) {
        currentPage = SHOOTING_DISTANCE_PAGE;
        shootingDistanceSet = shootingDistance;
      }
    } else if (currentPage == SENSORS_PAGE) {
      if (viewMode >= sensorPages) {
        viewMode = 0;
      } else {
        viewMode += 1;
      }
    } else if (currentPage == BRANA_PAGE) {
      if (menuPos[BRANA_PAGE] == 0) {
        EEPROM.put(adressGoal, branaModra);
        oponentsGoal = branaModra;
      } else if (menuPos[BRANA_PAGE] == 1) {
        EEPROM.put(adressGoal, branaZlta);
        oponentsGoal = branaZlta;
      }

    } else if (currentPage == COMPASS_PAGE) {
      double GyroAngle = getRotation();
      compassSetVal[menuPos[COMPASS_PAGE]] = (int)GyroAngle;
      menuPos[COMPASS_PAGE] += 1;
      if (menuPos[COMPASS_PAGE] > 3) {
        EEPROM.put(adressCompass, compassSetVal);
        for (int i = 0; i < compassValues; i++) {
          compassVal[i] = compassSetVal[i];
        }
        currentPage = SETUP_PAGE;
        menuPos[COMPASS_PAGE] = 0;
      }
    } else if (currentPage == RYCHLOST_MOTOROV_PAGE) {
      if (menuPos[RYCHLOST_MOTOROV_PAGE] == 0) {
        for (int i = 0; i < 4; i++) {
          motorSpeedSet[i] = motorSpeed[i];
        }
        currentPage = MAIN_SPEED_PAGE;
      } else if (menuPos[RYCHLOST_MOTOROV_PAGE] == 1) {
        for (int i = 0; i < 4; i++) {
          motorSpeedSet[i] = motorSpeed[i];
        }
        currentPage = FULL_SPEED_PAGE;
      } else if (menuPos[RYCHLOST_MOTOROV_PAGE] == 2) {
        for (int i = 0; i < 4; i++) {
          motorSpeedSet[i] = motorSpeed[i];
        }
        currentPage = TURN_SPEED_PAGE;
      } else if (menuPos[RYCHLOST_MOTOROV_PAGE] == 3) {
        for (int i = 0; i < 4; i++) {
          motorSpeedSet[i] = motorSpeed[i];
        }
        currentPage = DEFEND_SPEED_PAGE;
      }
    } else if (currentPage > 7 && currentPage < 12) {
      for (int i = 0; i < 4; i++) {
        motorSpeed[i] = motorSpeedSet[i];
      }
      EEPROM.put(adressMotorSpeed, motorSpeedSet);

      currentPage = RYCHLOST_MOTOROV_PAGE;
    } else if (currentPage == STRATEGY_PAGE) {
      EEPROM.put(adressStrategy, (menuPos[STRATEGY_PAGE] + 1));
      strategy = (menuPos[STRATEGY_PAGE] + 1);
    } else if (currentPage == MISUGE_PAGE) {
      EEPROM.put(adressMisugeVal, misugeValSet);
      misugeVal = misugeValSet;
      currentPage = VIEW_PAGE;
    } else if (currentPage == SHOOTING_DISTANCE_PAGE) {
      EEPROM.put(adressShootingDistance, shootingDistanceSet);
      shootingDistance = shootingDistanceSet;
      currentPage = VIEW_PAGE;
    }
    if (currentPage != CIARA_PAGE) {
      while (digitalRead(OK_BUTTON))
        ;
    }
  } else if (digitalRead(BACK_BUTTON)) {
    if (currentPage == MAIN_PAGE) {
      ;
    } else if (currentPage == SETUP_PAGE || currentPage == STRATEGY_PAGE || currentPage == VIEW_PAGE) {
      currentPage = MAIN_PAGE;
    } else if (currentPage == BRANA_PAGE || currentPage == RYCHLOST_MOTOROV_PAGE) {
      currentPage = SETUP_PAGE;
    } else if (currentPage == MAIN_SPEED_PAGE || currentPage == FULL_SPEED_PAGE || currentPage == TURN_SPEED_PAGE || currentPage == DEFEND_SPEED_PAGE) {
      currentPage = RYCHLOST_MOTOROV_PAGE;
    } else if (currentPage == SENSORS_PAGE || currentPage == PLAYSTYLE_PAGE || currentPage == MISUGE_PAGE || currentPage == SHOOTING_DISTANCE_PAGE) {
      currentPage = VIEW_PAGE;
    }
    while (digitalRead(BACK_BUTTON))
      ;
  } else if (digitalRead(EXIT_BUTTON)) {

    currentPage = MAIN_PAGE;
    menuPos[MAIN_PAGE] = 0;
    zostavaTestov = numberTests;
    for (int i = 0; i < numberSensors; i++) {
      ciaraInput[i] = 0;
    }
    menuPos[COMPASS_PAGE] = 0;
    while (digitalRead(EXIT_BUTTON))
      ;
  } else if (digitalRead(DOWN_BUTTON)) {
    if (currentPage > 7 && currentPage < 10) {
      motorSpeedSet[currentPage - 8] -= 5;
    } else if (currentPage > 9 && currentPage < 12) {
      motorSpeedSet[currentPage - 8] -= 1;
    } else if (currentPage == MISUGE_PAGE) {
      misugeValSet -= 5;
    } else if (currentPage == SHOOTING_DISTANCE_PAGE) {
      shootingDistanceSet -= 1;
    } else {
      if (menuPos[currentPage] < maxMenuPos[currentPage]) {
        menuPos[currentPage] += 1;
      } else {
        menuPos[currentPage] = 0;
      }
    }
    while (digitalRead(DOWN_BUTTON))
      ;
  } else if (digitalRead(UP_BUTTON)) {
    if (currentPage > 7 && currentPage < 10) {
      motorSpeedSet[currentPage - 8] += 5;
    } else if (currentPage > 9 && currentPage < 12) {
      motorSpeedSet[currentPage - 8] += 1;
    } else if (currentPage == MISUGE_PAGE) {
      misugeValSet += 5;
    } else if (currentPage == SHOOTING_DISTANCE_PAGE) {
      shootingDistanceSet += 1;
    } else {
      if (menuPos[currentPage] > 0) {
        menuPos[currentPage] -= 1;
      } else {
        menuPos[currentPage] = maxMenuPos[currentPage];
      }
    }
    while (digitalRead(UP_BUTTON))
      ;
  }

  oled.firstPage();
  do {
    (*pages[currentPage])();
  } while (oled.nextPage());
}

void loop(void) {
  ciara();
  blocks = pixy.ccc.getBlocks();
  xLopta = findXBySignature(lopta);
  yLopta = findYBySignature(lopta);
  xBrana = findXBySignature(oponentsGoal);
  yBrana = findYBySignature(oponentsGoal);
  GyroAngle = getRotation();
  if (misuge >= misugeVal) {
    if (jedenKrat == 0) {
      turn_right_defend();
      jedenKrat = 1;
    }
    if (analogRead(driblerPin) < hodnotaLedBrany) {
      if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
        move_forward();
      } else if (GyroAngle < GyrL) {
        turn_right_dotacanie();
      } else {
        turn_left_dotacanie();
      }
    } else {
      if (xLopta > 0) {
        if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
          move_forward();
          for (int i = 0; i < misugeForward; i = i + 1) {
            blocks = pixy.ccc.getBlocks();
            xLopta = findXBySignature(lopta);
            if (analogRead(driblerPin) < hodnotaLedBrany) {
              if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
                move_forward();
              } else if (GyroAngle < GyrL) {
                turn_right_dotacanie();
              } else {
                turn_left_dotacanie();
              }
            } else {
              if (xLopta > 0) {
                if (xLopta >= leftPerimeter && xLopta <= rightPerimeter) {
                  move_forward();
                  //motor_control(5, -driblerSpeed);
                } else if (xLopta > rightPerimeter) {
                  turn_right();
                } else if (xLopta < leftPerimeter) {
                  turn_left();
                }
              } else {
                if (GyroAngle >= GyrL && GyroAngle <= GyrR) {
                  move_backward();
                } else if (GyroAngle < GyrL) {
                  turn_right();
                } else {
                  turn_left();
                }
              }
            }
            misuge = misugeReset;
            /*Serial.print("\t");               
              Serial.print("Lopta ");
              Serial.print("\t");
              Serial.println(xLopta);*/
            delay(17);
            ciara();
          }

        } else if (xLopta > rightPerimeter) {
          turn_right();
        } else if (xLopta < leftPerimeter) {
          turn_left();
        }

      } else {
        if (GyroAngle > SupportR) {
          turn_left_defend();
        } else if (GyroAngle < SupportL) {
          turn_right_defend();
        }
      }
    }

  } else {
    jedenKrat = 0;
    if (xLopta == 0) {
      //misuge += 1;
      if (analogRead(driblerPin) > hodnotaLedBrany) {
        misuge = misuge + 1;
      } else {
        misuge = 0;
      }
      /*Serial.print("misuge");
      Serial.print("\t");
      Serial.println(misuge);*/

    } else {
      misuge = 0;
      /*Serial.print("misuge");
      Serial.print("\t");
      Serial.println(misuge);*/
    }
    strategyPlay(strategy);
  }
  /*Serial.print("\t");               
  Serial.print("Lopta ");
  Serial.print("\t");
  Serial.println(xLopta);
  Serial.print("\t");               
  Serial.print("GyroAngle ");
  Serial.print("\t");
  Serial.println(GyroAngle);*/
  delay(17);
}

void page1(void) {
  oled.setFont(u8g_font_profont12);
  oled.setPrintPos(0, 10);
  oled.print("SUBSCRIBE TECH VEGAN");
  oled.setPrintPos(0, 25);
  oled.print("LIKE-SHARE-COMMENT");
  oled.setPrintPos(0, 40);
  oled.print("ashishvegan.com");
  oled.setPrintPos(0, 55);
  oled.print("+91-9890345539");
}

void pageSetup(void) {
  oled.setFont(u8g_font_profont11);
  oled.setPrintPos(0, 10);
  oled.print("[ ]BRANA");
  oled.setPrintPos(0, 25);
  oled.print("[ ]CIARA");
  oled.setPrintPos(0, 40);
  oled.print("[ ]COMPASS");
  oled.setPrintPos(0, 55);
  oled.print("[ ]RYCHLOST MOTOROV");
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[1]) + 10);
  oled.print("+");
  //oled.setPrintPos(0, 55);
  //oled.print("");
}
void pageMain(void) {
  oled.setFont(u8g_font_profont11);
  oled.setPrintPos(0, 10);
  oled.print("[ ]RUN");
  oled.setPrintPos(0, 25);
  oled.print("[ ]SET UP");
  oled.setPrintPos(0, 40);
  oled.print("[ ]STRATEGY");
  oled.setPrintPos(0, 55);
  oled.print("[ ]VIEW");
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[MAIN_PAGE]) + 10);
  oled.print("+");
  //oled.setPrintPos(0, 55);
  //oled.print("");
}
void pageCiara(void) {



  oled.setFont(u8g_font_profont11);
  oled.setPrintPos(98, 10);

  oled.print((numberTests - zostavaTestov) + 1);
  oled.print("/");

  oled.print(numberTests);

  int aVzadu1, aVpravo1, aVpredu1, aVlavo1, aVzadu2, aVpravo2, aVpredu2, aVlavo2;
  aVpredu1 = analogRead(ciaraPins[0]);
  aVpredu2 = analogRead(ciaraPins[1]);
  aVpravo1 = analogRead(ciaraPins[2]);
  aVpravo2 = analogRead(ciaraPins[3]);
  aVzadu1 = analogRead(ciaraPins[4]);
  aVzadu2 = analogRead(ciaraPins[5]);
  aVlavo1 = analogRead(ciaraPins[6]);
  aVlavo2 = analogRead(ciaraPins[7]);
  oled.setPrintPos(0, 10);
  oled.print("F1: ");
  oled.print(aVpredu1);
  oled.print(" F2: ");
  oled.print(aVpredu2);
  oled.setPrintPos(0, 25);
  oled.print("R1: ");
  oled.print(aVpravo1);
  oled.print(" R2: ");
  oled.print(aVpravo2);
  oled.setPrintPos(0, 40);
  oled.print("B1: ");
  oled.print(aVzadu1);
  oled.print(" B2:");
  oled.print(aVzadu2);

  oled.setPrintPos(0, 55);

  oled.print("L1: ");
  oled.print(aVlavo1);

  oled.print(" L2:");
  oled.print(aVlavo2);
  //oled.setPrintPos(0, 55);
  //oled.print("");
}

void pageStrategy(void) {
  oled.setPrintPos(0, 10);
  oled.print("[ ]BRANA ONLY   [ ]");
  oled.setPrintPos(0, 25);
  oled.print("[ ]BRANA FIRST  [ ]");
  oled.setPrintPos(0, 40);
  oled.print("[ ]HYBRID STRAT [ ]");
  oled.setPrintPos(0, 55);
  oled.print("[ ]COMPASS FIRST[ ]");
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[STRATEGY_PAGE]) + 10);
  oled.print("+");
  oled.setPrintPos(17 * 6, (LINE_HEIGHT * (strategy - 1)) + 10);
  oled.print("*");
  //oled.setPrintPos(0, 55);
  //oled.print("");
}
void pageView(void) {
  oled.setPrintPos(0, 10);
  oled.print("[ ]SENSORS");
  oled.setPrintPos(0, 25);
  oled.print("[ ]PLAYSTYLE");
  oled.setPrintPos(0, 40);
  oled.print("[ ]MISUGE");
  oled.setPrintPos(0, 55);
  oled.print("[ ]SHOOTING DISTANCE");
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[VIEW_PAGE]) + 10);
  oled.print("+");
  //oled.setPrintPos(0, 55);
  //oled.print("");
}
void pageBrana(void) {
  oled.setPrintPos(0, 10);
  oled.print("[ ]MODRA[ ]");
  oled.setPrintPos(0, 25);
  oled.print("[ ]ZLTA [ ]");
  if (oponentsGoal == branaModra) {
    oled.setPrintPos(9 * 6, 10);
    oled.print("*");
  } else if (oponentsGoal == branaZlta) {
    oled.setPrintPos(9 * 6, 25);
    oled.print("*");
  }
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[BRANA_PAGE]) + 10);
  oled.print("+");
}
void pageCompass(void) {
  double GyroAngle = getRotation();
  oled.setPrintPos(12 * 6 - 3, 10);
  oled.print("ANG:");
  oled.print(GyroAngle);

  oled.setPrintPos(0, 10);
  oled.print("[   ]SupL");
  oled.setPrintPos(0, 25);
  oled.print("[   ]CmpL");
  oled.setPrintPos(0, 40);
  oled.print("[   ]CmpR");
  oled.setPrintPos(0, 55);
  oled.print("[   ]SupR");
  if (menuPos[COMPASS_PAGE] < 4) {
    oled.setPrintPos(6, (LINE_HEIGHT * menuPos[COMPASS_PAGE]) + 10);
    oled.print((int)GyroAngle);
  }
  for (int i = 0; i < menuPos[COMPASS_PAGE]; i++) {
    oled.setPrintPos(6, (LINE_HEIGHT * i) + 10);
    oled.print(compassSetVal[i]);
  }
}
void pageRychlostMotorov(void) {
  oled.setPrintPos(0, 10);
  oled.print("[ ]mainSeed: ");
  oled.print(motorSpeed[0]);
  oled.setPrintPos(0, 25);
  oled.print("[ ]fullSpeed: ");
  oled.print(motorSpeed[1]);
  oled.setPrintPos(0, 40);
  oled.print("[ ]turnSpeed: ");
  oled.print(motorSpeed[2]);
  oled.setPrintPos(0, 55);
  oled.print("[ ]defendSpeed: ");
  oled.print(motorSpeed[3]);
  oled.setPrintPos(6, (LINE_HEIGHT * menuPos[RYCHLOST_MOTOROV_PAGE]) + 10);
  oled.print("+");
  //oled.setPrintPos(0, 55);
  //oled.print("");
}
void pageMainSpeed(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]mainSeed = ");
  oled.print(motorSpeed[0]);
  oled.setPrintPos(6, 10);
  oled.print(motorSpeedSet[0]);
}
void pageFullSpeed(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]fullSeed = ");
  oled.print(motorSpeed[1]);
  oled.setPrintPos(6, 10);
  oled.print(motorSpeedSet[1]);
}
void pageTurnSpeed(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]turnSeed = ");
  oled.print(motorSpeed[2]);
  oled.setPrintPos(6, 10);
  oled.print(motorSpeedSet[2]);
}
void pageDefendSpeed(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]defendSeed = ");
  oled.print(motorSpeed[3]);
  oled.setPrintPos(6, 10);
  oled.print(motorSpeedSet[3]);
}
void pageSensors(void) {
  oled.setFont(u8g_font_profont11);
  blocks = pixy.ccc.getBlocks();
  int xBrana = findXBySignature(oponentsGoal);
  int yBrana = findYBySignature(oponentsGoal);
  int xLopta = findXBySignature(lopta);
  int yLopta = findYBySignature(lopta);
  double GyroAngle = getRotation();
  switch (viewMode) {
    case 0:
      oled.setPrintPos(0, 10);
      oled.print("F1: ");
      oled.print(ciaraVal[0]);
      oled.print(" F2: ");
      oled.print(ciaraVal[1]);
      oled.setPrintPos(0, 25);
      oled.print("R1: ");
      oled.print(ciaraVal[2]);
      oled.print(" R2: ");
      oled.print(ciaraVal[3]);
      oled.setPrintPos(0, 40);
      oled.print("B1: ");
      oled.print(ciaraVal[4]);
      oled.print(" B2: ");
      oled.print(ciaraVal[5]);
      oled.setPrintPos(0, 55);
      oled.print("L1: ");
      oled.print(ciaraVal[6]);
      oled.print(" L2: ");
      oled.print(ciaraVal[7]);
      break;
    case 1:
      int aVzadu1, aVpravo1, aVpredu1, aVlavo1, aVzadu2, aVpravo2, aVpredu2, aVlavo2;
      aVpredu1 = analogRead(ciaraPins[0]);
      aVpredu2 = analogRead(ciaraPins[1]);
      aVpravo1 = analogRead(ciaraPins[2]);
      aVpravo2 = analogRead(ciaraPins[3]);
      aVzadu1 = analogRead(ciaraPins[4]);
      aVzadu2 = analogRead(ciaraPins[5]);
      aVlavo1 = analogRead(ciaraPins[6]);
      aVlavo2 = analogRead(ciaraPins[7]);
      oled.setPrintPos(0, 10);
      oled.print("F1: ");
      oled.print(aVpredu1);
      oled.print(" F2: ");
      oled.print(aVpredu2);
      oled.setPrintPos(0, 25);
      oled.print("R1: ");
      oled.print(aVpravo1);
      oled.print(" R2: ");
      oled.print(aVpravo2);
      oled.setPrintPos(0, 40);
      oled.print("B1: ");
      oled.print(aVzadu1);
      oled.print(" B2: ");
      oled.print(aVzadu2);
      oled.setPrintPos(0, 55);
      oled.print("L1: ");
      oled.print(aVlavo1);
      oled.print(" L2: ");
      oled.print(aVlavo2);
      break;
    case 2:
      oled.setPrintPos(15 * 6 - 3, 10);
      oled.print("ANG:");
      oled.print((int)GyroAngle);

      oled.setPrintPos(0, 10);
      oled.print("[   ]SupL");
      oled.setPrintPos(0, 25);
      oled.print("[   ]CmpL");
      oled.setPrintPos(0, 40);
      oled.print("[   ]CmpR");
      oled.setPrintPos(0, 55);
      oled.print("[   ]SupR");
      for (int i = 0; i < 4; i++) {
        oled.setPrintPos(6, 10 + 15 * i);
        oled.print(compassVal[i]);
      }
      break;
    case 3:
      oled.setPrintPos(0, 10);
      oled.print("LOPTA");
      oled.setPrintPos(0, 25);
      oled.print("X: ");
      oled.print(xLopta);
      oled.print(" Y: ");
      oled.print(yLopta);
      oled.setPrintPos(0, 40);
      oled.print("BRANA");
      oled.setPrintPos(0, 55);
      oled.print("X: ");
      oled.print(xBrana);
      oled.print(" Y: ");
      oled.print(yBrana);
      break;
    case 4:
      oled.setPrintPos(0, 10);
      oled.print("mainSeed: ");
      oled.print(motorSpeed[0]);
      oled.setPrintPos(0, 25);
      oled.print("fullSpeed: ");
      oled.print(motorSpeed[1]);
      oled.setPrintPos(0, 40);
      oled.print("turnSpeed: ");
      oled.print(motorSpeed[2]);
      oled.setPrintPos(0, 55);
      oled.print("defendSpeed: ");
      oled.print(motorSpeed[3]);
      break;
    case 5:
      oled.setPrintPos(0, 10);
      oled.print("MODRA[ ]");
      oled.setPrintPos(0, 25);
      oled.print("ZLTA [ ]");
      if (oponentsGoal == branaModra) {
        oled.setPrintPos(6 * 6, 10);
        oled.print("*");
      } else if (oponentsGoal == branaZlta) {
        oled.setPrintPos(6 * 6, 25);
        oled.print("*");
      }
      break;
    case 6:
      oled.setPrintPos(0, 10);
      oled.print("BRANA ONLY   [ ]");
      oled.setPrintPos(0, 25);
      oled.print("BRANA FIRST  [ ]");
      oled.setPrintPos(0, 40);
      oled.print("HYBRID STRAT [ ]");
      oled.setPrintPos(0, 55);
      oled.print("COMPASS FIRST[ ]");
      oled.setPrintPos(14 * 6, (LINE_HEIGHT * (strategy - 1)) + 10);
      oled.print("*");
      break;
  }
  delay(17);
}
void pagePlaystyle(void) {
  oled.setPrintPos(0, 10);
  oled.print("UTOCIME NA ");
  if (oponentsGoal == branaModra) {
    oled.print("MODRU");
  } else if (oponentsGoal == branaZlta) {
    oled.print("ZLTU");
  }
  oled.setPrintPos(0, 25);
  switch (strategy) {
    case 1:
      oled.print("BRANA ONLY");
      break;
    case 2:
      oled.print("BRANA FIRST");
      break;
    case 3:
      oled.print("HYBRID STRAT");
      break;
    case 4:
      oled.print("COMPASS FIRST");
      break;
  }
  oled.setPrintPos(0, 40);
  oled.print("STRIELAME OD: ");
  oled.print(shootingDistance);

  oled.setPrintPos(0, 55);
  oled.print("BALL LOST OD: ");
  oled.print(misugeVal);
}
void pageMisuge(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]misugeVal = ");
  oled.print(misugeVal);
  oled.setPrintPos(6, 10);
  oled.print(misugeValSet);
}
void pageShootingDistance(void) {
  oled.setPrintPos(0, 10);
  oled.print("[   ]sDistance = ");
  oled.print(shootingDistance);
  oled.setPrintPos(6, 10);
  oled.print(shootingDistanceSet);
}
